"""
Threading prototypes
"""

# 	Copyright (c) 2005-2007 ALT Linux, Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 2 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import types
from threading import Thread
from cxutil.utils import opts

class ManagerThread (opts,Thread):
	'''
	A manager object, an event handler for dispatcher2
	'''
	bus = None

	def __init__(self,bus,name,dct={}):
		opts.__init__(self,dct)
		Thread.__init__(self)

		self.setName(name)
		self.bus = bus

		if hasattr(self,"post"):
			self.post()

	def run(self):
		while True:
			addr = {}
			message = self.bus.get(addr)

			if type(message) == types.DictType:
				message["addr"] = addr["from"]
				target = message["map"]
				if hasattr(self,target):
					target = getattr(self,target)
					message = target(message)
				else:
					print "DEBUG: unknown symbol %s" % (target)

				if message:
					self.bus.put(addr["from"],message)

			elif message == "shutdown":
				return
